# 股票报警公众号

## 介绍

用户可以开通一个公众号，然后运行一个程序来监控一些股票的成交记录，当越价、成交额超过自定义的限度时，可以将此信息通过微信公众号推送给自己。

## 限制

由于此应用使用了公众号的模板消息，所以需要申请服务号，否则无法推送模板消息。

## 依赖

本app依赖以下python包：
- requests
- flask
- futuquant及futuquant的依赖包

## 使用

1. 申请服务号类型的公众号
2. 在公众号上创建模板消息：
   ```
    {{first.DATA}}
    股票名称：{{keyword1.DATA}}
    当前价格：{{keyword2.DATA}}
    成交金额：{{keyword3.DATA}}
    成交数量：{{keyword4.DATA}}
    成交时间：{{keyword5.DATA}}
    {{remark.DATA}}
   ```
2. 在公众号上将服务器地址指向正确地址：http://???/wx_flask。此地址的ip需要加入到公众号的ip白名单里。这台机器上需要安装python和futuquant及相关依赖包。推荐使用python3.5+.
2. 将FutuOpenD部署到上述服务器上。启动FutuOpenD
3. 启动公众号后台服务进程，python3 web_service.py. 文件内容如下：
    ```
    from futuquant.examples.app.stock_alarm.config import config
    config.appid = '???'        # 公众号AppId，可在公众号后台管理界面查看
    config.secrect = '???'      # 公众号AppSecret，可在公众号后台管理界面查看
    config.token = '???'        # 公众号token，可在公众号后台管理界面查看
    config.template_id = '???'  # 模板消息id，可在公众号后台管理界面添加，内容见上面说明
	
    # 设置报警相关参数
    config.premium_rate = 0.005           # parameter: 越价率
    config.warning_threshold = 1000000    # 成交额报警阈值，即成交额超过多少报警。当越价率超过阈值后才会判断次阈值
    config.large_threshold = 5000000      # 大单报警阈值，即成交额超过多少就一定报警。此报警与上面越价率无关。
    config.warning_limit = 5    # 1分钟内最多发出几次报警

    # 设置FutuOpenD的ip和端口
    config.host = '127.0.0.1'   # FutuOpenD的ip
    config.port = 11111         # FutuOpenD的端口号

    from futuquant.examples.app.stock_alarm.wx_service import app
    app.run(host='0.0.0.0', port=80, debug=True)
    ```
5. 启动监控进程, python3 start_monitor.py, 文件内容如下：
    ```
	from futuquant.examples.app.stock_alarm.config import config
    config.appid = '???'
    config.secrect = '???'
    config.token = '???'
    config.template_id = '???'  # 模板消息id
	config.test_user_list = ['???']  # 自己的微信openid，可以在公众号里输入whoami查询
    
    # 设置报警相关参数
    config.premium_rate = 0.005           # parameter: 越价率
    config.warning_threshold = 1000000    # 成交额报警阈值，即成交额超过多少报警。当越价率超过阈值后才会判断次阈值
    config.large_threshold = 5000000      # 大单报警阈值，即成交额超过多少就一定报警。此报警与上面越价率无关。
    config.warning_limit = 5    # 1分钟内最多发出几次报警

    # 设置FutuOpenD的ip和端口
    config.host = '127.0.0.1'   # FutuOpenD的ip
    config.port = 11111         # FutuOpenD的端口号
	
    from futuquant.examples.app.stock_alarm.data_acquisition import quote_test
    stock_list = ['HK.02318', 'HK.02828']  # 监控的股票列表
    quote_test(stock_list, config.host, config.port)   # 开始监控
    ```
